//notation: js file can only use this kind of comments
//since comments will cause error when use in webview.loadurl,
//comments will be remove by java use regexp
(function() {

    if (window.WebViewJavascriptBridge) {
        return;
    }

    function init(messageHandler) {
       window.defHandler = messageHandler;
    }
// 注册线程 往数组里面添加值
    function registerHandler(handlerName, handler) {
        Native.callbacks[handlerName] = handler;
    }

    function send(data, callback) {
        CallNative("",data,callback);
    }

    function callHandler(handlerName, data, callback) {
        CallNative(handlerName,data,callback);
    }

    function CallNative(name, body, callBack) {
        var id = "";
        var param;
        if(!body){
            param = "";
        }else if(typeof body === 'string'){
            param = body;
        }else{
            try{
                param = JSON.stringify(body);
            }catch(e){
               param = body;
            }
        }
        if(callBack && typeof callBack === 'function'){
            var date = new Date();
            var id = date.toISOString();
            Native.callbacks[id] = callBack;
        }
        return window.bridge.callNative(name,param,id);
    }

    function NativeCallBack(id, body) {
        if (!id) {
            return;
        } else if("undefined" == id) {
            if(checkCallBack(defHandler)){
                defHandler();
            }
            return;
        }
        if (!Native.callbacks) {
            return;
        }
        var callBack = Native.callbacks[id];
        if(checkCallBack(callBack)){
            try{
                if (body) {
                    callBack(body);
                } else {
                    callBack();
                }
            }catch(e){
                console.log(e);
            }
        }
    }

    function checkCallBack(callBack){
        return callBack && (typeof callBack === 'function')
    }

    var Native = window.Native = {
        init: init,
        send: send,
        registerHandler: registerHandler,
        callHandler: callHandler,
        callbacks: {},
    };

    window.NativeCallBack = NativeCallBack;
    var WebViewJavascriptBridge = window.WebViewJavascriptBridge = window.Native;
    window.bridge.initFinish();
})();
